state("rpcs3") {}

init {
	long baseAddr = 0x300000000;

	current.GameTime = (uint)0;
	vars.cnt = 300;

	vars.Pointer = (Func<uint, uint[], uint>)((addr, offsets) => {
		uint ptr = addr;
		foreach (uint offset in offsets) {
			ptr = vars.ReadUint(ptr);
			if (ptr == 0) return 0;
			ptr += offset;
		}
		return ptr;
	});

	vars.ReadUint = (Func<uint, uint>)((addr) => {
		if (addr == 0) return 0;
	    uint val = memory.ReadValue<uint>((IntPtr)(baseAddr + addr));
	    return (val & 0x000000FF) << 24 |
	            (val & 0x0000FF00) << 8 |
	            (val & 0x00FF0000) >> 8 |
	            ((uint)(val & 0xFF000000)) >> 24;
  	});

  	vars.ReadString = (Func<uint, int, string>)((addr, length) => {
  		if (addr == 0) return string.Empty;
  		return memory.ReadString((IntPtr)(baseAddr + addr), length);
  	});
}

update {
	if (++vars.cnt > 300) {
		string targetProduct = "NPUB30609";
	  	string productCode = vars.ReadString(0x20010251, 9);
	  	if (productCode != targetProduct) {
	  		vars.cnt = 0;
	  		throw new Exception("MGS2 code " + targetProduct + " not found");
	  	}
	}
	else return false;

	current.GameTime = vars.ReadUint(vars.Pointer(0x11A4F30, new uint[] { 0x138 }));
}

gameTime {
	return TimeSpan.FromMilliseconds(current.GameTime * 1000 / 60);
}

isLoading {
	return true;
}

start {
	if(old.GameTime > current.GameTime && current.GameTime == 0) return true;
}